//---------------------------------------------------------------------------
// File: TMainForm.h, TDx_Play_Library, Example2 - Connections
//
// Date: 13th January, 2004
// Author: Darren John Dwyer
// Copyright: (c) 2002-2004 Darren John Dwyer, All Rights Reserved.
//
// Description:
// Once you have created a DirectPlay interface, you need to setup a DirectPlay
// connection. Connections can be made via IPX, TCP/IP, Modem, Serial-Cable.
//
// This example shows how to enumerate DirectPlay connections are available
// using a created DirectPlay interface. It shows create a DirectPlay connection
// and destroy a DirectPlay connection.
//
//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include "TDx_Play.h"
#include "TDPName.h"
#include "tdpcaps.h"
//---------------------------------------------------------------------------

#if (__BORLANDC__ < 0x0530) // BCB Version 1
class TMainForm : public TForm
{
#else // BCB Version 3 or 4
class PACKAGE TMainForm : public TForm
{
#endif

__published:
//---------------------------------------------------------------------------
// Anything that is to be displayed within the Object Inspector
//---------------------------------------------------------------------------

	TDx_Play *Dx_Play1;
	TPanel *Panel1;
	TBitBtn *CreateButton;
	TBitBtn *EnumConnectionsButton;
	TBitBtn *GetCapabilitiesButton;
	TBitBtn *InitConnectionButton;
	TBitBtn *DestroyButton;
	TPanel *Panel2;
	TLabel *Label1;
	TLabel *Label2;
	TPanel *Panel3;
	TLabel *Label3;
	TPanel *Panel4;
	TLabel *Label4;
	TPanel *Panel5;
	TLabel *Label5;
	TListBox *CapsListBox;
	TMemo *Memo1;
	TListBox *ConnectionsListBox;
	TMemo *StatusMemo;
	TLabel *Label7;
	TLabel *StatusLabel;
	TBitBtn *CloseConnectionButton;
	TBitBtn *ExitButton;
	TLabel *NumConnectionsLabel;
	TDPCaps *DPCaps1;
	TLabel *ConnectionInitializedLabel;
	TLabel *Label8;
	TLabel *Label9;
	TLabel *Label10;
	void __fastcall CreateButtonClick(TObject *Sender);
	void __fastcall DestroyButtonClick(TObject *Sender);
	void __fastcall Dx_Play1Create(TObject *Sender);
	void __fastcall Dx_Play1Destroy(TObject *Sender);
	void __fastcall Dx_Play1Error(TObject *Sender, AnsiString Function,
	AnsiString Error, AnsiString ErrorMessage);

	void __fastcall EnumConnectionsButtonClick(TObject *Sender);
	
	void __fastcall GetCapabilitiesButtonClick(TObject *Sender);
	void __fastcall InitConnectionButtonClick(TObject *Sender);

	void __fastcall Dx_Play1EnumConnections(TObject *Sender, const GUID *Guid,
	void *Connection, DWORD ConnectionSize, TDPName *Name, DWORD Flags,
	void *Context, bool &Continue);
	
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall CloseConnectionButtonClick(TObject *Sender);
public:
//---------------------------------------------------------------------------
// Anything available to other classes and/or code
//---------------------------------------------------------------------------

    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();


	#define MAX_CONNECTIONS		20

	dword		NumConnections;
    GUID		ConnectionGuids[MAX_CONNECTIONS];
    void*		ConnectionBuffers[MAX_CONNECTIONS];
    dword		ConnectionSizes[MAX_CONNECTIONS];
    TDPName*	ConnectionNames[MAX_CONNECTIONS];
    dword		ConnectionFlags[MAX_CONNECTIONS];

    bool		ConnectionInitialized;

protected:
//---------------------------------------------------------------------------
// Anything available only to classes descended from this class
//---------------------------------------------------------------------------

private:
//---------------------------------------------------------------------------
// Private data not accessible except from within this class
//---------------------------------------------------------------------------
};
//---------------------------------------------------------------------------
#if (__BORLANDC__ < 0x0530) // BCB Version 1
extern TMainForm *MainForm;
#else // BCB Version 3 or 4
extern PACKAGE TMainForm *MainForm;
#endif
//---------------------------------------------------------------------------
#endif
